% A6_34
%% a) Definition der Strecke
Tt=log(2);
Gs=tf([1],[1 1 0]);Gs.outputd=Tt;
   
%% b) realer PD-Regler mit FKL-Verfahren im SISO-Tool:
Gr=tf([1 1],[0.1 1]);
sisotool(Gs,Gr);
kR=0.752;   % im SISO-Tool ermittelt
Gr=kR*Gr;
   
% Wahl der Abtastzeit:
% einerseits muss gelten Tt=d*T_A mit d ganzzahlig und Tt=ln(2)=0.693, 
% andererseits sollte wenigstens T_A<Pi/40=0,0785 sein
% => daher T_A=Tt/9
T_A=Tt/9;
Grz=c2d(Gr,T_A);

%% c) Deadbeat-Entwurf fr diskretisierte Strecke
% maximale sinnvolle Abtastzeit fr direktes Verfahren: T_A_DB<Pi/4=0.785
% => daher T_A_DB=Tt/1=0.693
T_A_DB=Tt;
Gsz=c2d(Gs,T_A_DB);
set(Gsz,'Variable','z^-1');
pzmap(Gsz);
% Deadbeat-Regler (von Hand berechnet)
Gr_DB=tf([1 -1.5 0.5],[0.3465 0 -0.1931 -0.1534],T_A_DB,'Variable','z^-1');

%% d) Simulation in Simulink
% hierfr zunchst alle Koeffizienten-Arrays extrahieren:
[nS,dS]=tfdata(Gs);                 % Strecke
[nR,dR]=tfdata(Gr);                 % kontinuierlicher Regler
[nRz,dRz,dummy]=tfdata(Grz);        % diskretisierter kontinuierlicher Regler
[nR_DB,dR_DB,dummy]=tfdata(Gr_DB);  % direkt diskret entworfener Deadbeat-Regler
% Simulation ffnen
A6_34d;

% Verkleinerung der Totzeit um Faktor 0.8
Tt=0.8*Tt;
A6_34d;